<template>
  <!-- 弹出框表单 -->
  <el-dialog :title="title" :visible.sync="open" width="50%" append-to-body>
    <el-form ref="form" :model="form" :rules="rules" label-width="120px">
      <el-row>

        <Field :span="20" label="姓名" prop="personId" v-model="form.name" placeholder="请输入个人姓名"/>
        <Field :span="20" label="联系方式" prop="contact" v-model="form.contact" placeholder="请输入联系方式"/>
        <Field :span="20" label="证件类型" prop="idCardType" v-model="form.idCardType" type="radio" :enumData="dict.idCardType" placeholder="请输入证件类型"/>
        <Field :span="20" label="证件号码" prop="idCardNo" v-model="form.idCardNo" placeholder="请输入证件号码"/>

      </el-row>

    </el-form>
    <div slot="footer" class="dialog-footer">
      <el-button type="primary" v-if="pageInfo.type !== 'view'" @click="submitForm">确 定</el-button>
      <el-button @click="cancel">取 消</el-button>
    </div>
  </el-dialog>
</template>

<script>
import form from "@/assets/mixins/formdialog";
import dialogShow from "./dialogshow";

export default {
  mixins: [form],
  components: {
    dialogShow,
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 弹出层标题
      title: "预约自动签到服务约束",
      // 是否显示弹出层
      open: false,
      toString: [
        "createMethod",
        "constraint",
        "idCardType",
        "personId",
      ],
      // 表单校验
      rules: {}
    };
  },

  methods: {
    /** 编辑 */
    edit(row) {
      this.reset()
      this.query = {id: row.id};
      this.urls.currUrl = "appointment/constraint/edit";
      this.getData();
      this.pageInfo.type = "edit"
      this.title = "修改预约自动签到服务约束";
    },
    /** 新增 */
    add(row) {
      this.reset()
      this.urls.currUrl = "appointment/constraint/add";
      this.getData();
      this.pageInfo.type = "add"
      this.title = "新增预约自动签到服务约束";
    },
    /** 查看*/
    view(row) {
      this.reset()
      this.query = {id: row.id};
      this.urls.currUrl = "appointment/constraint/view";
      this.getData();
      this.pageInfo.type = "view"
      this.title = "预约自动签到服务约束详细";
    },
    /**取消按钮 */
    cancel() {
      this.open = false;
    },
    /**获取数据后弹框 */
    afterRender(data) {
      this.open = true;
    },

    beforeSubmit(data) {
      data.name = this.dict['personId'][data.personId];
      return data;
    },

    afterSubmit(data) {
      this.open = false;
      this.$emit("ok");
    },

    // 表单重置
    reset() {
      this.form = {
        siteId: null,
        siteName: "",
        personId: null,
        name: "",
        contact: "",
        idCardType: "",
        idCardNo: "",
        accumulative: 0,
        constraintTime: null,
        createMethod: null,
        operator: "",
        constraint: 0,
      };
      this.resetForm("form");
    },
    resetForm(refName) {
      if (this.$refs[refName]) {
        this.$refs[refName].resetFields();
      }
    },
  },
};
</script>
